Status: Closed

Priority: Normal

Assignee: Jurgen Fischer
Category: Data Provider/Oracle

Affected QGIS version:2.2.0
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 18559

Description

Hello,

when you open a layer in Oracle Spatial, the first query grabs the list of the tables with their SRID. Then Qgis launch a query per layer to

grab the geometry type and SRID also:

SELECT DISTINCT t."COLONNE_GEOMETRIQUE".SDO_GTYPE,t."COLONNE_GEOMETRIQUE".SDO_SRID
FROM (SELECT "GEOM" FROM "SCHEMA"."TABLE_A_INTERROGER" WHERE "COLONNE_GEOMETRIQUE" IS NOT

NULL AND rownum<=100) t
WHERE NOT t."COLONNE_GEOMETRIQUE" IS NULL;

When this table specific query is launched, a layerProperty.srids.clear() is made (see src/provider/oracle/qggsoracleconn.cpp). Then the

SRID is computed from the results of the query above.

When you have an empty layer, this query returns nothing and then the SRID of the layer is unknown even when it is well declared in
USER_SDO_GEOM_METADATA (or ALL_SDO_GEOM_METADATA).

So, | believe that the layerProperty.srids.clear() function should only be launched when there are SRIDs returned by the query above. If no
SRIDs are returned, just keep the one that has been returned for the complete tables list query. | think that the layerProperty.srids.clear()
statement should be in the bloc code that get the srids (and the geometry). Otherwise it can perhaps be completly removed...

Associated revisions

Revision 3978bff4 - 2014-04-19 10:14 PM - Jiirgen Fischer
oracle provider:
- retrieve comment of materialized views (implements #10063)
- use detected srid (fixes #10091)
- initialize mUseEstimatedMetadata (fixes #10092)
- also consider username in temporary saved credentials (fixes #10093)

History

#1 - 2014-04-18 10:11 AM - Jiirgen Fischer
- Target version changed from Version 2.4 to Future Release - High Priority
- Category set to Data Provider/Oracle

#2 - 2014-04-19 01:15 PM - Jiirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"3978bff44709dd251f1739b441a5934f06653011".
https://github.com/qgis/QGIS/blob/18efe2e1d40b248e42dc4f3a6ac43456729796be/src/providers/oracle/qgsoracleconn.cpp
